/*
 *  Copyright (C) 2002 Tomasz Kojm <zolw@konarski.edu.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "others.h"
#include "shared.h"

int hex2int(int c)
{
    if (!isascii(c))
    	return -1;
    if (isdigit(c))
	return c - '0';
    if ((c >= 'a') && (c <= 'f'))
	return c + 10 - 'a';

    mprintf("!hex2int() translation problem (%d)\n", c);
    return -1;
}

char *hex2str(const char *hex)
{
	char *str, *ptr;
	int i, len, val, c;

    len = strlen(hex);

    /* additional check - hex strings are parity length here */
    if(len % 2 != 0) {
	mprintf("!Malformed hexstring: %s (length: %d)\n", hex, len);
	return NULL;
    }

    str = mcalloc((len / 2) + 1, sizeof(char));
    ptr = str;

    for(i = 0; i < len; i += 2) {
	if((c = hex2int(hex[i])) >= 0) {
	    val = c;
	    if((c = hex2int(hex[i+1])) >= 0) {
		val = (val << 4) + c;
	    } else return NULL;
	} else return NULL;

	*ptr++ = val;
    }

    return str;
}

void chomp(char *string)
{
    if(string[strlen(string) - 1] == 10 || string[strlen(string) - 1 ] == 13)
	string[strlen(string) -1] = 0;
}
